local function StefanHud(v, player)
	if (player.mo and player.mo.valid)
		if player.mo.skin == "stefan"
			if not (CBW_Battle)
				local barx = 16
				local bary = 78
				local color = 122
				local BarFlags = V_HUDTRANS|V_PERPLAYER|V_SNAPTOTOP|V_SNAPTOLEFT|V_AQUAMAP
				local BarFlags2 = color+BarFlags
				v.drawString(15, 63, "Stamina", BarFlags2)
				v.drawScaled((barx-1)*FRACUNIT, bary*FRACUNIT, FRACUNIT, v.cachePatch("SNBAR2"), BarFlags)
				if player.mo.stefanwhite ~= nil
					local ener2 = player.mo.stefanwhite*(FRACUNIT/49)
					if player.mo.stefanwhite > 0
						v.drawStretched((barx-1)*FRACUNIT, bary*FRACUNIT, ener2, FRACUNIT, v.cachePatch("SNBAR1"), BarFlags, v.getColormap(TC_DEFAULT, SKINCOLOR_WHITE))
					end
				end
				if player.mo.stefanstamina ~= nil
					local ener = player.mo.stefanstamina*(FRACUNIT/49)
					if player.mo.stefanstamina > 0
						v.drawStretched((barx-1)*FRACUNIT, bary*FRACUNIT, ener, FRACUNIT, v.cachePatch("SNBAR1"), BarFlags, v.getColormap(TC_DEFAULT, SKINCOLOR_CYAN))
					end
				end
				v.drawScaled((barx-1)*FRACUNIT, bary*FRACUNIT, FRACUNIT, v.cachePatch("SNBAR0"), BarFlags)
			end
		end
	end
end

hud.add(StefanHud)

local f = 350

local function stefanf(v, player)
	if f > 0
		if f < 350
			if not (f > 320 and f % 2 == 0) and not (f < 30 and f % 2 == 0)
				v.drawString(160, 156, "for Sonic Robo Blast 2", V_ALLOWLOWERCASE|V_PERIDOTMAP, "thin-center")
				v.drawString(160, 168, "created by Pupsik228", V_ALLOWLOWERCASE|V_PERIDOTMAP, "thin-center")
				v.drawString(160, 184, "Coding by Scarf the Wolf/Mr.FondusBroMan", V_ALLOWLOWERCASE|V_PERIDOTMAP, "thin-center")
			end
		end
	end
	if f > 0
		f = $ - 3
	end
end

hud.add(stefanf, "title")