if not Stefan then rawset(_G, "Stefan", {}) end

local sf = Stefan

sf.CheckPlayer = function(m1, m2,bruh)
	if m1 and m1.valid and m2 and m2.valid and m1.player and m1.player.valid and m2.player and m2.player.valid
		local p1 = m1.player
		local p2 = m2.player
		if (gametyperules & GTR_TEAMS)
			if cv_friendlyfire.value or (gametyperules & GTR_FRIENDLYFIRE)
				return false
			else
				if p1.ctfteam and p2.ctfteam and p1.ctfteam == p2.ctfteam
					return true
				else
					return false
				end
			end
		else
			if not G_CoopGametype()
				return false
			else
				if cv_friendlyfire.value >= 1
					return false
				else
					return true
				end
			end
		end
	end
	return false
end

local magentashield_tics = 10*TICRATE/2

local function MagentaAttackAura(player, deathfx)
	local scale = player.mo.scale/2
	if (deathfx != nil)
		scale = deathfx>>1
	else
		deathfx = 4<<FRACBITS
	end
	local dist = FixedMul(deathfx,32)
	local hang = P_RandomRange(0,7) * ANGLE_45
	local vang = P_RandomRange(0,7) * ANGLE_45
	local orb = P_SpawnMobj(
		player.mo.x + (dist * cos(hang+ANGLE_180)) + (dist * sin(vang+ANGLE_180)),
		player.mo.y + (dist * sin(hang+ANGLE_180)) + (dist * sin(vang+ANGLE_180)),
		player.mo.z + (player.mo.height>>1) + (dist * cos(vang+ANGLE_180)),
		MT_THOK
	)
	orb.scale = scale
	orb.momx = ((dist/8) * cos(hang)) + ((dist/8) * sin(vang))
	orb.momy = ((dist/8) * sin(hang)) + ((dist/8) * sin(vang))
	orb.momz = (dist/8) * cos(vang)
	orb.fuse = 8
	orb.color = SKINCOLOR_MASTER
	orb.colorized = true
	orb.blendmode = AST_ADD
	orb.target = player.mo
	orb.tracer = player.mo
end

//local checkspeed

rawset(_G, "stfnspeed", function(player)
	if twodlevel and not rphys then
		return FixedMul(player.runspeed*2/3, player.mo.scale)
	else
		return FixedMul(player.runspeed, player.mo.scale)
	end
end)

local function GotSuperMicroware(player)
	if emeralds == 127 and player.rings >= 100 and not P_IsObjectOnGround(player.mo)
	and player.pflags & PF_JUMPED
		return true
	else
		return false
	end
end

addHook("PreThinkFrame", function(player)
	for player in players.iterate
		if player.mo and player.mo.valid and player.mo.skin == "stefan"
		and player.playerstate == PST_LIVE and not (player.powers[pw_carry] == CR_NIGHTSMODE)
			if GotSuperMicroware(player) and not player.mo.emeraldpower and not (player.pflags & PF_SPINDOWN)
			and (player.cmd.buttons & BT_SPIN) and not player.powers[pw_shield] and not player.powers[pw_invulnerability] and not player.powers[pw_super]
				player.stefansuper = true
				player.pflags = $ & ~PF_SPINNING
				S_StartSound(player.mo, sfx_s3k9c)
				S_StopMusic(player)
				P_DoSuperTransformation(player)
			end
		end
	end
end)

addHook("PlayerThink", function(player)
	if player.mo and player.mo.valid
		if player.playerstate == PST_LIVE
			//Magenta Emerald
			if not (player.checkstefan)
				player.checkstefan = 0
			end
			if player.mo.skin == "stefan"
				player.checkstefan = 2
			else
				if player.checkstefan > 0
					player.checkstefan = $1 - 1
				end
			end
			if player.checkstefan >= 1
				if not (player.magentaemerald) or not (player.magentaemerald.valid)
					player.magentaemerald = P_SpawnMobj(
						player.mo.x + P_ReturnThrustX(player.mo, player.drawangle + ANGLE_45, -20*FRACUNIT), 
						player.mo.y + P_ReturnThrustY(player.mo, player.drawangle + ANGLE_45, -20*FRACUNIT),
						player.mo.z + player.mo.height/2,
						MT_MAGENTAEMERALD
					)
					player.magentaemerald.target = player.mo
				end
				if P_LookForEnemies(player, false) and (player.magentaemerald) and not (player.magentaemerald.tracer) and not (player.checkstefan)
					player.magentaemerald.tracer = P_LookForEnemies(player, false)
				end
			else
				if player.magentaemerald and player.magentaemerald.valid then
					local dd = P_SpawnGhostMobj(player.magentaemerald)
					dd.blendmode = AST_ADD
					dd.fuse = TICRATE/3
					dd.destscale = 0
					dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
					P_KillMobj(player.magentaemerald)
					player.magentaemerald = nil
				end
			end
			//
			local apex = FixedMul(4*player.mo.scale, min(skins[player.mo.skin].jumpfactor, FRACUNIT)) --Determine jump apex,
			if player.mo.eflags & MFE_UNDERWATER --Correct for being underwater,
				apex = 117*$/200
			end
			if player.stefansuper == nil
				player.stefansuper = false
			end
			if player.mo.skin != "stefan"
				if player.stefansuper == true
					player.stefansuper = false
				end
			end
			//Magenta Magic
			if player.mo.skin == "stefan"
				if player.playerstate == PST_LIVE
					if player.stefansuper == true
						player.charflags = $1|SF_SUPER
					end
					if player.powers[pw_super]
						player.stefansuper = true
						local TRBall = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-30, 30)*FRACUNIT, P_RandomRange(-30, 30)*FRACUNIT, P_RandomRange(0, 50)*FRACUNIT, MT_THOK)
						TRBall.state = S_TAN_TRNSFLAME1
						TRBall.blendmode = AST_ADD
						TRBall.fuse = 0
						TRBall.destscale = 0
						TRBall.color = SKINCOLOR_PURPLE
						TRBall.colorized = true
						local TRBall2 = P_SpawnMobjFromMobj(player.mo, P_RandomRange(-20, 20)*FRACUNIT, P_RandomRange(-20, 20)*FRACUNIT, P_RandomRange(0, 30)*FRACUNIT, MT_THOK)
						TRBall2.state = S_TAN_TRNSFLAME1
						TRBall2.blendmode = AST_ADD
						TRBall2.fuse = 0
						TRBall2.destscale = 0
						TRBall2.color = SKINCOLOR_PASTEL
						TRBall2.colorized = true
						P_SetObjectMomZ(TRBall, 2*FRACUNIT, false)
						P_SetObjectMomZ(TRBall2, 4*FRACUNIT, false)
					else
						if player.stefansuper == true
							player.stefansuper = false
						else
							player.charflags = $1 & ~SF_SUPER
						end
					end
					if not (player.stefanshield)
                        player.stefanshield = 0
                    end
					if not (player.mo.stefanwhite)
						player.mo.stefanwhite = 0
					end
					if player.mo.stefanwhite > 0
						player.mo.stefanwhite = $1 - 1
					end
					//Dash Fly
					if not (player.mo.dashfly)
						player.mo.dashfly = 0
					end
					if player.mo.dashfly > 0
						player.mo.dashfly = $1 - 1
					end
					if player.mo.dashfly > 0 and not P_PlayerInPain(player) and not (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						player.pflags = $1|PF_CANCARRY
						player.mo.state = S_PLAY_FLY
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINNING
						local dd = P_SpawnGhostMobj(player.mo)
						dd.blendmode = AST_ADD
						dd.fuse = TICRATE/3
						dd.destscale = 0
						dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
						if not (player.mo.eflags & MFE_UNDERWATER)
							if (leveltime % 3) == 1
								S_StartSound(player.mo, sfx_putput)
							end
						end
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 10*FRACUNIT/2, false)
						else
							P_SetObjectMomZ(player.mo, 10*FRACUNIT, false)
						end
					end
					if player.mo.dashfly > 0 and not P_PlayerInPain(player) and (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						player.mo.state = S_PLAY_WALK
						player.mo.dashfly = 0
					end
					if player.mo.dashfly == 1 and not P_PlayerInPain(player) and not (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						if not (CBW_Battle)
							player.mo.stefanfly = 7*TICRATE
						end
						player.mo.stfnslowfall = 1
					end
					//Slow Fall
					if not (player.mo.stfnslowfall)
						player.mo.stfnslowfall = 0
					end
					if not (player.mo.stefanfly)
						player.mo.stefanfly = 0
					end
					if player.mo.stefanfly > 0
						player.mo.stefanfly = $1 - 1
					end
					if player.mo.stfnslowfall == 1 and not P_PlayerInPain(player) and not (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						if (player.cmd.buttons & BT_JUMP)
							player.mo.state = S_PLAY_FLY
							player.pflags = $1|PF_CANCARRY
							if not (player.mo.eflags & MFE_UNDERWATER)
								if (leveltime % 3) == 1
									S_StartSound(player.mo, sfx_putput)
								end
							end
							if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz > 0
							or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz < 0
								if (leveltime & 1) == 1
									P_SetObjectMomZ(player.mo, -1*FRACUNIT, true)
								end
							elseif player.mo.momz > -apex and player.mo.momz < apex
								P_SetObjectMomZ(player.mo, -3*FRACUNIT)
							else
								P_SetObjectMomZ(player.mo, -3*FRACUNIT)
							end
							if not (CBW_Battle)
								if player.mo.stefanfly <= 0
									player.mo.state = S_PLAY_FALL
									player.mo.stfnslowfall = 0
								end
							end
						else
							player.pflags = $1 & ~PF_CANCARRY
							player.mo.state = S_PLAY_FALL
							player.mo.stfnslowfall = 0
						end
					end
					if player.mo.stfnslowfall > 0 and not P_PlayerInPain(player) and (P_IsObjectOnGround(player.mo)) and not (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
					and not player.powers[pw_carry]
						player.pflags = $1 & ~PF_CANCARRY
						player.mo.state = S_PLAY_WALK
						player.mo.stfnslowfall = 0
					end
					//Stamina
					if not (player.mo.stefanstamina)
						player.mo.stefanstamina = 0
					end
					if player.mo.stefanstamina >= 0
						if (leveltime % 22 == 0)
							if player.mo.stefanstamina <= 49
								player.mo.stefanstamina = $1 + 3
							end
						end
					end
					if player.mo.stefanstamina > 49
						player.mo.stefanstamina = 49
					end
					if not (player.mo.stefancheckdamage)
						player.mo.stefancheckdamage = 0
					end
					//Magenta Shield Pain
					if not (player.mo.magentashield_paintics)
						player.mo.magentashield_paintics = 0
					end
					if player.mo.magentashield_paintics > 0
						player.mo.magentashield_paintics = $1 - 1
					end
					if player.mo.magentashield_paintics > 0
						player.mo.state = S_PLAY_PAIN
						player.pflags = $1 & ~PF_APPLYAUTOBRAKE
						P_ResetPlayer(player)
						player.powers[pw_nocontrol] = 2
						if (P_IsObjectOnGround(player.mo))
							S_StartSound(player.mo, sfx_s3k49)
							if (player.mo.eflags & MFE_UNDERWATER)
								P_SetObjectMomZ(player.mo, 4*FRACUNIT/2, false)
							else
								P_SetObjectMomZ(player.mo, 4*FRACUNIT, false)
							end
						end
					end
					if not (player.mo.stefanstomp)
						player.mo.stefanstomp = false
					end
					if player.mo.stefanstomp == true
						player.mo.stefanctm2 = 1
						if not ((P_IsObjectOnGround(player.mo)))
							if (leveltime & 1) then
								local ghostcombo = P_SpawnGhostMobj(player.mo)
								if ghostcombo and ghostcombo.valid then
									ghostcombo.color = player.mo.color
									ghostcombo.blendmode = AST_ADD
									ghostcombo.colorized = true
								end
							end
							if not (player.mo.eflags & MFE_GOOWATER)
								P_SetObjectMomZ(player.mo, -4*FRACUNIT, 1)
							else
								player.mo.stefanstompcldwn = 10*TICRATE
								player.mo.stefanstomp = false
							end
							if not (player.mo.state == S_PLAY_ROLL)
								player.mo.state = S_PLAY_ROLL
							end
						else
							player.mo.state = S_PLAY_STND
							P_RadiusAttack(player.mo, player.mo, 500*FRACUNIT)
							P_Earthquake(player.mo, player.mo, 256*FRACUNIT)
							if player == consoleplayer
								P_StartQuake(50*FRACUNIT, 10)
							end
							S_StartSound(player.mo, sfx_pstop)
							for x=player.mo.x,player.mo.x+player.mo.radius,player.mo.radius
								for y=player.mo.y,player.mo.y+player.mo.radius,player.mo.radius
									local ss = R_PointInSubsector(x,y)
									for fof in ss.sector.ffloors()
										if (fof.flags & FF_BUSTUP) and (fof.flags & FF_EXISTS)
											if (player.mo.z+player.mo.momz==fof.topheight or player.mo.z+player.mo.height+player.mo.momz==fof.bottomheight or (player.mo.eflags & MFE_VERTICALFLIP and (player.mo.z+player.mo.momz==fof.bottomheight or player.mo.z-player.mo.height-player.mo.momz==fof.topheight)))
												EV_CrumbleChain(ss.sector, fof)
												player.mo.state = S_PLAY_ROLL
												player.crumbled = true
												player.restoremomz = true
											end
										end
									end
								end
							end
							player.mo.stefanstompcldwn = 10*TICRATE
							player.mo.stefanstomp = false
						end
					end
					if player.restoremomz
						player.mo.momz = player.storemomzforcrumble
						player.restoremomz = nil
					end
					player.storemomzforcrumble = player.mo.momz
					if (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
						player.mo.stefanstomp = false
					end
					//
					if P_PlayerInPain(player) or (CBW_Battle and (player.tumble != nil and player.tumble > 0))
					or player.mo.state == S_PLAY_PAIN or player.mo.sprite2 == SPR2_PAIN or (player.powers[pw_justsprung] or (player.mo.eflags & MFE_SPRUNG))
						player.mo.stefancheckdamage = 1 player.mo.magentashield_paintics = 0
						//Abilities
						player.mo.dashfly = 0
						player.mo.stfnslowfall = 0
						player.mo.stefanstomp = false
						//
					else
						player.mo.stefancheckdamage = 0
					end
					local CR_Table = {
						CR_GENERIC = 0, CR_PLAYER = 1, CR_NIGHTSFALL = 2, CR_BRAKGOOP = 3, CR_ROPEHANG = 4, CR_ZOOMTUBE = 5, CR_MACESPIN = 6,
						CR_MINECART = 7, CR_ROLLOUT = 8, CR_PTERABYTE = 9, CR_DUSTDEVIL = 10
					}
					for i = 0, #CR_Table, 1 do
						if player.powers[pw_carry] == CR_Table[i]
							player.mo.stefancheckdamage = 1 player.mo.magentashield_paintics = 0
							//Abilities
							player.mo.dashfly = 0
							player.mo.stfnslowfall = 0
							player.mo.stefanstomp = false
							//
						end
					end
					if player.mo.stefancheckdamage == 1
						if player.mo.magentashield > 0
							player.mo.mshld_tics = magentashield_tics
							player.mo.magentashield = 0
						end
						player.mo.stefanstomp = false
						if player.mo.matack > 0
							player.mo.matak_tics = 10*TICRATE
							player.mo.matack = 0
						end
						if player.mo.magentathok > 0
							if not (CBW_Battle)
								player.mo.mgnthktics = 10*TICRATE
							else
								player.mo.mgnthktics = 20*TICRATE
							end
							player.mo.magentathok = 0
						end
					end
					//Magenta Shield
					if not (player.mo.magentashield)
						player.mo.magentashield = 0
					end
					if player.mo.magentashield > 0
						player.mo.magentashield = $1 - 1
					end
					if player.mo.magentashield > 0
						player.mo.stefanctm1 = 1
					end
					if player.mo.magentashield == 1
						player.mo.mshld_tics = magentashield_tics
					end
					if not (player.mo.mshld_tics)
						player.mo.mshld_tics = 0
					end
					if player.mo.mshld_tics > 0
						player.mo.mshld_tics = $1 - 1
					end
					if player.mo.mshld_tics >= 1
						player.mo.stefanctm1 = 1
					end
					if not (player.mo.stefanctm1)
						player.mo.stefanctm1 = 0
					end
					if not (player.cmd.buttons & BT_CUSTOM1)
						player.mo.stefanctm1 = 0
					end
					if (player.cmd.buttons & BT_CUSTOM1)
					and not (player.pflags & PF_STASIS)
					and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
					and player.mo.stefanctm1 == 0
					and not player.exiting
					and not player.mo.mshld_tics
					and not player.mo.stefancheckdamage
					and not player.mo.magentashield
					and player.mo.stefanstamina >= 30
					and not P_PlayerInPain(player)
					and not player.powers[pw_carry]
					and not player.powers[pw_nocontrol]
					and not (CBW_Battle)
						player.mo.stefanwhite = player.mo.stefanstamina
						player.mo.stefanstamina = $1 - 30
						S_StartSound(player.mo, sfx_s3k78)
						local magentashield_start = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
						magentashield_start.color = SKINCOLOR_TURQUOISE
						magentashield_start.colorized = true
						magentashield_start.blendmode = AST_ADD
						magentashield_start.scale = player.mo.scale
						magentashield_start.destscale = player.mo.scale*8
						magentashield_start.target = player.mo
						magentashield_start.sprite = SPR_SCFE
						magentashield_start.frame = A|FF_FULLBRIGHT
						player.tracer = magentashield_start
						magentashield_start.eflags = player.mo.eflags&MFE_VERTICALFLIP
						local magentashield = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_MAGENTASHIELD)
						magentashield.color = SKINCOLOR_TURQUOISE
						magentashield.colorized = true
						magentashield.blendmode = AST_ADD
						magentashield.target = player.mo
						player.tracer = magentashield
						player.mo.magentashield = 5*TICRATE
					end
					//Magenta Attack
					if not (player.mo.matak_tics)
						player.mo.matak_tics = 0
					end
					if player.mo.matak_tics > 0
						player.mo.matak_tics = $1 - 1
					end
					if player.mo.matak_tics >= 1
						player.mo.stefanctm2 = 1
					end
					if not (player.mo.matack)
						player.mo.matack = 0
					end
					if player.mo.matack > 0
						player.mo.matack = $1 - 1
					end
					if player.mo.matack > 0
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINNING
						player.mo.momx = 8*$/9 player.mo.momy = 8*$/9
						MagentaAttackAura(player)
						if (leveltime & 3) == 1
							S_StartSound(player.mo, sfx_s3k5c)
							player.mo.state = S_PLAY_SPINDASH
						end
					end
					if player.mo.matack == 1
						S_StartSound(player.mo, sfx_tblr)
						local a = P_SpawnGhostMobj(player.magentaemerald)
						a.color = SKINCOLOR_MASTER
						a.colorized = true
						a.blendmode = AST_ADD
						a.sprite = SPR_SCFE
						a.scale = player.mo.scale/2
						a.frame = A|FF_FULLBRIGHT
						player.mo.state = S_PLAY_FALL
						if (player.mo.eflags & MFE_UNDERWATER)
							P_SetObjectMomZ(player.mo, 9*FRACUNIT/2, false)
							P_InstaThrust(player.mo, player.drawangle, -8*FRACUNIT/2)
						else
							P_SetObjectMomZ(player.mo, 9*FRACUNIT, false)
							P_InstaThrust(player.mo, player.drawangle, -8*FRACUNIT)
						end
						P_SPMAngle(player.mo, MT_MGNTATTACK, player.mo.angle, 1)
						player.mo.matak_tics = 10*TICRATE
					end
					if not (player.mo.stefanctm2)
						player.mo.stefanctm2 = 0
					end
					if not (player.cmd.buttons & BT_CUSTOM2)
						player.mo.stefanctm2 = 0
					end
					if not (player.mo.stefanstompcldwn)
						player.mo.stefanstompcldwn = 0
					end
					if player.mo.stefanstompcldwn > 0
						player.mo.stefanstompcldwn = $1 - 1
					end
					if player.mo.stefanstompcldwn > 0
						player.mo.stefanctm2 = 1
					end
					if (player.cmd.buttons & BT_CUSTOM2)
					and not (player.pflags & PF_STASIS)
					and not (player.mo.tracer and player.mo.tracer.type == MT_TUBEWAYPOINT)
					and player.mo.stefanctm2 == 0
					and not player.exiting
					and not player.mo.stefancheckdamage
					and not player.mo.matack
					and not player.mo.magentathok
					and not P_PlayerInPain(player)
					and not player.powers[pw_carry]
					and not (CBW_Battle)
					and not player.powers[pw_nocontrol]
						if not player.powers[pw_super]
							if player.mo.stefanstamina >= 20
								player.mo.stefanwhite = player.mo.stefanstamina
								player.mo.stefanstamina = $1 - 20
								player.mo.dashfly = 0
								player.mo.stfnslowfall = 0
								player.mo.momz = 0
								local mgntthok = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_THOK)
								mgntthok.color = player.mo.color
								mgntthok.colorized = true
								mgntthok.blendmode = AST_ADD
								mgntthok.scale = player.mo.scale
								mgntthok.destscale = player.mo.scale*8
								mgntthok.target = player.mo
								mgntthok.sprite = SPR_SCFE
								mgntthok.frame = A|FF_FULLBRIGHT
								player.tracer = mgntthok
								mgntthok.eflags = player.mo.eflags&MFE_VERTICALFLIP
								S_StartSound(player.mo, sfx_thok)
								S_StartSound(player.mo, sfx_cdfm62)
								player.mo.magentathok = 25
							end
						else
							if player.mo.stefanstamina >= 35
								if not (P_IsObjectOnGround(player.mo))
									player.mo.stefanwhite = player.mo.stefanstamina
									player.mo.stefanstamina = $1 - 35
									player.rings = $1 - 20
									player.mo.dashfly = 0
									player.mo.stfnslowfall = 0
									player.mo.stefanstomp = true
									S_StartSound(player.mo, sfx_s3k78)
									player.mo.stefanctm2 = 1
								end
							end
						end		
					end
					//Magenta Thok
					if not (player.mo.stefanctm3)
						player.mo.stefanctm3 = 0
					end
					if not (player.cmd.buttons & BT_CUSTOM3)
						player.mo.stefanctm3 = 0
					end
					if not (player.mo.magentathok)
						player.mo.magentathok = 0
					end
					if player.mo.magentathok > 0
						player.mo.magentathok = $1 - 1
					end
					if player.mo.magentathok > 0
						player.pflags = $1|PF_THOKKED
						player.pflags = $|PF_FULLSTASIS
						player.pflags = $1 & ~PF_JUMPED
						player.pflags = $1 & ~PF_SPINNING
						player.mo.state = S_PLAY_ROLL
						local dd = P_SpawnGhostMobj(player.mo)
						dd.blendmode = AST_ADD
						dd.fuse = TICRATE/3
						dd.destscale = 0
						dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
						dd.color = player.magentaemerald.color
						local dd = P_SpawnGhostMobj(player.magentaemerald)
						dd.blendmode = AST_ADD
						dd.fuse = TICRATE/3
						dd.destscale = 0
						dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
						if not (player.mo.eflags & MFE_VERTICALFLIP) and player.mo.momz > 0
						or player.mo.eflags & MFE_VERTICALFLIP and player.mo.momz < 0
							if (leveltime & 1) == 1
								P_SetObjectMomZ(player.mo, -1*FRACUNIT, true)
							end
						elseif player.mo.momz > -apex and player.mo.momz < apex
							player.mo.momz = 0
						end
						player.powers[pw_nocontrol] = 2
						if (player.mo.eflags & MFE_UNDERWATER)
							P_InstaThrust(player.mo, player.drawangle, 50*FRACUNIT/2)
						else
							P_InstaThrust(player.mo, player.drawangle, 50*FRACUNIT)
						end
						player.mo.stefanctm2 = 1
					end
					if player.mo.magentathok == 1
						player.mo.state = S_PLAY_FALL
						player.pflags = $1 & ~PF_JUMPED
						if not (CBW_Battle)
							player.mo.mgnthktics = 10*TICRATE
						else
							player.mo.mgnthktics = 20*TICRATE
						end
					end
					if not (player.mo.mgnthktics)
						player.mo.mgnthktics = 0
					end
					if player.mo.mgnthktics > 0
						player.mo.mgnthktics = $1 - 1
					end
					if player.mo.mgnthktics > 0
						player.mo.stefanctm2 = 1
					end
				end
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if (player.mo and player.mo.valid and player.mo.skin == "stefan" and player.playerstate == PST_LIVE)
	and not (P_IsObjectOnGround(player.mo))
	and not (player.gotflag or player.gotcrystal)
	and not player.mo.dashfly
	and not player.mo.stfnslowfall
	and not player.mo.matack
	and not player.mo.magentathok
	and not (player.pflags & PF_THOKKED)
	and not P_LookForEnemies(player)
		if not player.mo.matack
			S_StartSound(player.mo, sfx_spin)
			player.mo.dashfly = 15
			player.pflags = $1|PF_THOKKED
		else
			player.pflags = $1|PF_THOKKED
		end
	end
end)

addHook("MobjThinker", function(mo)
	if mo.target and mo.target.valid
		local z
		if mo.eflags & MFE_VERTICALFLIP
			z = mo.target.z-mo.target.height/2
		else
			z = mo.target.z
		end
		if mo.type == MT_MAGENTASHIELD
			P_MoveOrigin(mo, mo.target.x, mo.target.y, z)
		else
			P_MoveOrigin(mo, mo.target.x+P_ReturnThrustX(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.y+P_ReturnThrustY(mo, mo.target.player.drawangle, mo.target.scale*3*-1), mo.target.z)
		end
		if not mo.target.magentashield
			local magentashield_start = P_SpawnMobjFromMobj(mo.target, 0, 0, 0, MT_THOK)
			magentashield_start.color = SKINCOLOR_TURQUOISE
			magentashield_start.colorized = true
			magentashield_start.blendmode = AST_ADD
			magentashield_start.scale = mo.target.scale
			magentashield_start.destscale = mo.target.scale*8
			magentashield_start.target = mo.target
			magentashield_start.sprite = SPR_SCFE
			magentashield_start.frame = A|FF_FULLBRIGHT
			P_RemoveMobj(mo)
		end
	end
	if mo and mo.valid and mo.type == MT_MAGENTASHIELD
		mo.color = SKINCOLOR_TURQUOISE
		mo.blendmode = AST_ADD
		mo.shadowscale = 0
		if mo.target and mo.target.player
			if mo.target.player.playerstate == PST_DEAD
			or P_PlayerInPain(mo.target.player)
			or (CBW_Battle and (mo.target.player.tumble != nil and mo.target.player.tumble > 0)) //Tumble Fix
			or mo.target.player.state == S_PLAY_DEAD
			or mo.target.player.state == S_PLAY_DRWN
			or mo.target.player.state == S_PLAY_PAIN //xd
			or mo.target.player.state == S_PLAY_STUN //Why not?
				P_RemoveMobj(mo)
			end
		end
	end
end, MT_MAGENTASHIELD)

sf.StefanLerp = function(a, b, w)
    return FixedMul((FRACUNIT - w), a) + FixedMul(w, b)
end

addHook("MobjThinker", function(mo)
	if not (mo.target)
		P_KillMobj(mo)
		return
	end
	if mo and mo.valid
		if mo.target.player.playerstate == PST_LIVE
			local target = mo.target
			local player = target.player
			if not mo.target.player.checkstefan
				P_KillMobj(mo)
				return
			end
			mo.angle = mo.target.player.drawangle or mo.target.angle
			mo.eflags = mo.target.eflags&MFE_VERTICALFLIP
			mo.tics = 2
			mo.sprite = SPR_STPN
			mo.scale = mo.target.scale
			mo.frame = A|FF_FULLBRIGHT
			if mo.target.color == SKINCOLOR_MAGENTA
				mo.color = SKINCOLOR_SKY
			else
				mo.color = mo.target.color
			end
			//Upgraded by Scarf/Mr.FondusBroMan
			if (mo.tracer == nil)
				local posangle = player.drawangle+ANGLE_180+ANG20
				if (target.eflags & MFE_VERTICALFLIP)
					P_MoveOrigin(
						mo, 
						sf.StefanLerp(mo.x, target.x + FixedMul(cos(posangle), 46*FRACUNIT), FRACUNIT/4), 
						sf.StefanLerp(mo.y, target.y + FixedMul(sin(posangle), 46*FRACUNIT), FRACUNIT/4),
						sf.StefanLerp(mo.z, target.z + target.height/2  - FixedMul(13*FRACUNIT, target.scale) + (2 * cos(ANG10*leveltime)), FRACUNIT/4)
					)
				else
					P_MoveOrigin(
						mo, 
						sf.StefanLerp(mo.x, target.x + FixedMul(cos(posangle), 46*FRACUNIT), FRACUNIT/4), 
						sf.StefanLerp(mo.y, target.y + FixedMul(sin(posangle), 46*FRACUNIT), FRACUNIT/4),
						sf.StefanLerp(mo.z, target.z + target.height/2 + (2 * cos(ANG10*leveltime)), FRACUNIT/4)
					)
				end
			end
		else
			local dd = P_SpawnGhostMobj(mo)
			dd.blendmode = AST_ADD
			dd.fuse = TICRATE/3
			dd.destscale = 0
			dd.frame = $|(FF_TRANS10 * (10 - min(dd.fuse, 10)))
		end
	end
end, MT_MAGENTAEMERALD)

addHook("MobjThinker", function(mo)
	mo.rollangle = $+ANG20
	mo.color = SKINCOLOR_MASTER
	mo.colorized = true
	mo.blendmode = AST_ADD
	local f = P_SpawnGhostMobj(mo)
	f.scale = mo.scale
	f.fuse = TICRATE/3
	f.state = S_MGNTATTACK_SPIN
	f.color = SKINCOLOR_MASTER
	f.colorized = true
	f.blendmode = AST_ADD
	f.frame = $|(FF_TRANS10 * (10 - min(f.fuse, 10)))
	P_InstaThrust(mo, mo.angle, 80*FRACUNIT)
end, MT_MGNTATTACK)

addHook("ShouldDamage", function(mo, inflictor, source, damage, damagetype)
	if mo and mo.valid and mo.skin == "stefan" and not mo.player.powers[pw_carry] and not mo.player.powers[pw_shield]
		local player = mo.player
		if mo.magentashield
			if inflictor and inflictor.valid
				if inflictor.flags & MF_BOXICON
				or damagetype & DMG_DEATHMASK
					return
				end
				local magentashield_start = P_SpawnMobjFromMobj(source, 0, 0, 0, MT_THOK)
				magentashield_start.color = SKINCOLOR_TURQUOISE
				magentashield_start.colorized = true
				magentashield_start.blendmode = AST_ADD
				magentashield_start.scale = source.scale
				magentashield_start.destscale = source.scale*8
				magentashield_start.target = source
				magentashield_start.sprite = SPR_SCFE
				magentashield_start.frame = A|FF_FULLBRIGHT
				mo.player.powers[pw_flashing] = 25
				mo.mshld_tics = magentashield_tics
				if not P_PlayerInPain(player)
					S_StartSound(mo, sfx_shldls)
					return true
				else
					return
				end
				mo.magentashield_paintics = 25
				mo.magentashield = 0
				return false
			end
		end
	end
end, MT_PLAYER)

addHook("PlayerCanDamage", function(player)
	if (player.mo.skin == "stefan")
		if player.mo.magentathok then
			return true
		end
    end
end)

addHook("MusicChange", function(oldname, newname)
	if splitscreen
		return
	end
	if not (consoleplayer and consoleplayer.valid)
		return
	end
	local scarf_music = skins[consoleplayer.skin].name
	if scarf_music == "stefan"
		if newname == "_super" then
			newname = "stefan"
		end
		return newname, mflags, looping, position, prefadems, fadeinms
	end
end)

addHook("PlayerSpawn", function(player)
	if not (player and player.valid and player.mo and player.mo.valid) then 
		return 
	end
	if player.mo.skin == "stefan"
		if not (player.playerstate == PST_LIVE) then return end
		player.mo.stefanstamina = 49
	end
end)

print("\n"+"\x89\Stefan The Fox \x80\- \x88\Sprites by Pupsik228", "\x87\Coding by Scarf the Wolf/Mr.FondusBroMan", "\x81\Stefan The Fox V2.0")
print("\n"+"\x85"+"Stefan The Fox\x80 for [SRB2 2.2.11+]"+"\n")